import { Base, Point, Type, EventArgs, INotifyPropertyChanged, IEnumerable, IList, PropertyChangedEventArgs } from "igniteui-angular-core";
import { DomRenderer, DomWrapper } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { EventProxy } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { PieChartStyleInfo } from "./PieChartStyleInfo";
import { BrushCollection } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PieChartVisualData } from "./PieChartVisualData";
import { Style } from "igniteui-angular-core";
import { Control } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { LabelsPosition } from "./LabelsPosition";
import { List$1 } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { LeaderLineType } from "./LeaderLineType";
import { ILegendOwner } from "igniteui-angular-core";
import { ILegendSeries } from "igniteui-angular-core";
import { ILegendTemplateProvider } from "igniteui-angular-core";
import { FastItemsSource } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { OthersCategoryType } from "./OthersCategoryType";
import { IndexCollection } from "./IndexCollection";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { IChartLegend } from "igniteui-angular-core";
import { SweepDirection } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { SliceSelectionMode } from "./SliceSelectionMode";
import { ObjectCollection } from "igniteui-angular-core";
import { BindingFormatter } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core";
import { SelectedItemChangingEventArgs } from "./SelectedItemChangingEventArgs";
import { SelectedItemsChangingEventArgs } from "./SelectedItemsChangingEventArgs";
import { SelectedItemChangedEventArgs } from "./SelectedItemChangedEventArgs";
import { SelectedItemsChangedEventArgs } from "./SelectedItemsChangedEventArgs";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { PieSliceVisualData } from "./PieSliceVisualData";
import { MouseEventArgs } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class PieChartViewManager extends Base {
    static $t: Type;
    n: DomRenderer;
    protected p: DomWrapper;
    protected s: DomWrapper;
    protected r: DomWrapper;
    protected q: DomWrapper;
    private k;
    private j;
    private l;
    protected ap: Rect;
    e: RenderingContext;
    g: RenderingContext;
    f: RenderingContext;
    h: RenderingContext;
    private a;
    constructor(a: PieChartBaseView);
    aa(): void;
    ad(a: number, b: number): void;
    ae(): void;
    ab(): void;
    z(): void;
    w(a: number, b: number): void;
    ao(): Rect;
    d(): FontInfo;
    an(): Point;
    ah(a: () => void): void;
    b(): PieChartStyleInfo;
    ai(a: Path): void;
    c: EventProxy;
    ac(a: any): void;
    v(a: DomWrapper): void;
    af(a: boolean): void;
    t(): any;
    x(a: PieChartVisualData): void;
    private _toolTipObject;
    private u;
    private i;
    ak(a: any): void;
    aj(pos_: Point, context_: PieSliceDataContext): void;
    y(a: PieSliceDataContext): void;
    al(style_: Style): Brush;
    am(style_: Style): Brush;
    m(style_: Style): number;
    ag(): void;
}
/**
 * @hidden
 */
export declare class LabelClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get item(): any;
    get allowSliceClick(): boolean;
    set allowSliceClick(a: boolean);
    private c;
}
/**
 * @hidden
 */
export declare class SliceClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get isSelected(): boolean;
    set isSelected(a: boolean);
    private d;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    private c;
    get isOthersSlice(): boolean;
    get index(): number;
    get dataContext(): any;
    private _originalEvent;
    get originalEvent(): any;
    set originalEvent(a: any);
}
/**
 * @hidden
 */
export declare class PieLabel extends Control {
    static $t: Type;
    constructor();
    ah: Slice;
    ao: Rect;
    ai: number;
    aj: any;
    ap: Line;
    aq: Path;
    ag: LabelsPosition;
    ak(a: PieChartBaseView): void;
    al(): void;
    am(): void;
    an(): void;
}
/**
 * @hidden
 */
export declare abstract class PieChartBase extends Control implements INotifyPropertyChanged, ILegendOwner, ILegendSeries, ILegendTemplateProvider {
    static $t: Type;
    a2(): PieChartBaseView;
    gb(a: PieChartBaseView): void;
    a3: PieChartBaseView;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    private bu;
    private bx;
    private bw;
    private by;
    private bv;
    private b1;
    private b0;
    private bz;
    private readonly a7;
    private readonly cn;
    private readonly cp;
    private readonly co;
    private readonly cq;
    private dd;
    bg: FastItemsSource;
    private bk;
    get bp(): IFastItemColumn$1<number>;
    set bp(a: IFastItemColumn$1<number>);
    df: number;
    c7: number;
    dc: number;
    ch: List$1<number>;
    cg: List$1<number>;
    cf: List$1<any>;
    cx: number;
    ce: List$1<UIElement>;
    get cu(): number;
    a6: PieChartSliceSelector;
    private _xsr;
    private get XSRP();
    get d1(): string;
    itemsSource: IEnumerable;
    actualItemsSource: IEnumerable;
    static readonly hc: DependencyProperty;
    get c3(): number;
    set c3(a: number);
    fl: string;
    ea: string;
    ep: string;
    private bi;
    get bl(): IFastItemColumn$1<any>;
    set bl(a: IFastItemColumn$1<any>);
    private bj;
    get bm(): IFastItemColumn$1<any>;
    set bm(a: IFastItemColumn$1<any>);
    az: LabelsPosition;
    il: Brush;
    ik: Brush;
    ij: Brush;
    ii: Brush;
    iz: Visibility;
    iv: Style;
    a0: LeaderLineType;
    c5: number;
    di: any;
    c6: number;
    a1: OthersCategoryType;
    ew: string;
    cy: number;
    get ct(): number;
    c9: number;
    get cw(): number;
    b3: boolean;
    b2: boolean;
    get explodedSlices(): IndexCollection;
    set explodedSlices(a: IndexCollection);
    private au;
    legend: IChartLegend;
    c4: number;
    db: number;
    io: SweepDirection;
    get selectedSlices(): IndexCollection;
    set selectedSlices(a: IndexCollection);
    private av;
    iw: Style;
    ix: Style;
    iy: Style;
    am: BrushCollection;
    ak: BrushCollection;
    an: BrushCollection;
    al: BrushCollection;
    d6: string;
    ag: any[];
    e0: string;
    aj: any[];
    em: string;
    ah: any[];
    er: string;
    ai: any[];
    legendItemTemplate: DataTemplate;
    legendItemBadgeTemplate: DataTemplate;
    static readonly hm: DependencyProperty;
    get gz(): DataTemplate;
    set gz(a: DataTemplate);
    b8: boolean;
    ca: boolean;
    cb: boolean;
    protected b5(): boolean;
    protected b6(): boolean;
    a4: (obj: any) => string;
    a5: (obj: any) => string;
    private cs;
    get c8(): number;
    set c8(a: number);
    private cr;
    get cv(): number;
    set cv(a: number);
    be: SliceSelectionMode;
    get selectedItem(): any;
    set selectedItem(a: any);
    static readonly h7: DependencyProperty;
    private _selectedItems;
    get selectedItems(): ObjectCollection;
    set selectedItems(a: ObjectCollection);
    labelClick: (sender: any, e: LabelClickEventArgs) => void;
    f3(a: any, b: LabelClickEventArgs): void;
    selectedItemChanging: (sender: any, e: SelectedItemChangingEventArgs) => void;
    f5(a: any, b: SelectedItemChangingEventArgs): void;
    selectedItemsChanging: (sender: any, e: SelectedItemsChangingEventArgs) => void;
    f8(a: any, b: SelectedItemsChangingEventArgs): void;
    selectedItemChanged: (sender: any, e: SelectedItemChangedEventArgs) => void;
    f4(a: any, b: SelectedItemChangedEventArgs): void;
    selectedItemsChanged: (sender: any, e: SelectedItemsChangedEventArgs) => void;
    f6(a: any, b: SelectedItemsChangedEventArgs): void;
    sliceClick: (sender: any, e: SliceClickEventArgs) => void;
    ga(a: any, b: SliceClickEventArgs): void;
    br: Pool$1<Slice>;
    bq: Pool$1<PieLabel>;
    fp(a: Slice, b: boolean): void;
    gp(a: Slice, b: boolean): void;
    gq(a: Slice): void;
    dg(a: Slice): any;
    it(a: Slice, b: LabelsPosition): Rect;
    b4(a: PieLabel, b: Point): boolean;
    static da(a: number): number;
    private b7;
    private static cz;
    static gv(a: List$1<PieLabel>): void;
    gn(a: List$1<PieLabel>): void;
    protected fn(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gj(): void;
    gc(): void;
    ge(): void;
    private e7;
    gd(): void;
    iu: Rect;
    gm(): void;
    gk(): void;
    private static c0;
    private static ip;
    private static c1;
    private static iq;
    gl(): void;
    bf(): PieChartVisualData;
    dw(): string;
    protected bn(a: string): IFastItemColumn$1<number>;
    protected bo(a: string): IFastItemColumn$1<any>;
    ap: BindingFormatter;
    as: BindingFormatter;
    aq: BindingFormatter;
    ar: BindingFormatter;
    protected gf(a: any, b: string, c: any, d: any): void;
    protected ao(a: BrushCollection): BrushCollection;
    protected im(a: Brush): Brush;
    private e6;
    private e8;
    private ci;
    protected cl(): IEnumerable;
    protected go(a: NotifyCollectionChangedEventArgs): void;
    protected f7(a: NotifyCollectionChangedEventArgs): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected gh(a: string, b: any, c: any): void;
    private gy;
    private gx;
    gt(a: Slice, b: MouseEventArgs): void;
    gu(a: Slice, b: MouseEventArgs, c: boolean): void;
    gs(a: Point): void;
    b9(a: Slice, b: MouseEventArgs): boolean;
    fr(a: any, b: any): void;
    fu(a: any, b: any, c: boolean): void;
    ft(a: any, b: any): void;
    fs(a: any, b: MouseEventArgs): void;
    f9(): void;
    provideContainer(a: any): void;
    f1(a: number, b: number): void;
    notifyContainerResized(): void;
    is(): Rect;
    ir(): Point;
    destroy(): void;
    fq(): void;
    private dj;
    get fg(): string;
    set fg(a: string);
    get container(): ILegendOwner;
    get isStacked(): boolean;
    get isVertical(): boolean;
    get hasMarkers(): boolean;
    get isUsableInLegend(): boolean;
    get hasSubItems(): boolean;
    c2(a: Slice): number;
    fz(source_: any, a: number, b: any, c: any): void;
    fv(source_: any): void;
    private cc;
    static cd(a: any, b: any): boolean;
    fx(source_: any, a: number, b: any): void;
    fy(source_: any, a: number, b: any): void;
    gr(source_: any): void;
    gi(): void;
    gw(): void;
    bh(): FontInfo;
    resolveLegendIndex(): number;
    forSubItems(a: (arg1: any) => void): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartSliceSelector extends Base {
    static $t: Type;
    private a;
    constructor(a: PieChartBase);
    d(a: Slice): boolean;
    c(a: Slice): boolean;
    h(a: Slice): any;
    f(a: any, b: boolean): boolean;
    e(a: any): boolean;
    g(a: any): boolean;
    b(a: any): boolean;
    k(a: Slice): void;
    i(a: Slice): void;
    j(a: Slice): void;
}
/**
 * @hidden
 */
export declare class PieSliceOthersContext extends Base {
    static $t: Type;
    private _data;
    get data(): IList;
    set data(a: IList);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
}
/**
 * @hidden
 */
export declare class Slice extends ContentControl {
    static $t: Type;
    ak(): SliceView;
    bl(a: SliceView): void;
    al: SliceView;
    constructor();
    a3: number;
    ax: number;
    a1: number;
    a0: number;
    static readonly bv: DependencyProperty;
    get isSelected(): boolean;
    set isSelected(a: boolean);
    static readonly bt: DependencyProperty;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    static readonly bu: DependencyProperty;
    get isOthersSlice(): boolean;
    set isOthersSlice(a: boolean);
    b7: Point;
    b5: Point;
    a2: number;
    ay: number;
    a5: number;
    get b2(): Brush;
    set b2(a: Brush);
    static readonly bp: DependencyProperty;
    a4: number;
    b8: Rect;
    ai: PieChartBase;
    aj: PieLabel;
    bf: string;
    b9: Rect;
    b3: Point;
    aq: boolean;
    au: boolean;
    av: boolean;
    ac(): void;
    az(): number;
    private cb;
    b6(): Point;
    private an;
    get aw(): boolean;
    set aw(a: boolean);
    bk(): void;
    ap(a: Point): boolean;
    private ao;
    private ca;
    am(): PieSliceVisualData;
    private static b4;
    b0: Brush;
    b1: Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartBaseView extends Base {
    static $t: Type;
    constructor(a: PieChartBase);
    a: PieChartBase;
    a1(): void;
    bb(): void;
    ax(): void;
    a0(): void;
    bs: Brush;
    b: PieChartStyleInfo;
    protected h: RenderingContext;
    protected j: RenderingContext;
    protected i: RenderingContext;
    protected k: RenderingContext;
    c: PieChartViewManager;
    ay(a: any): void;
    b0(): Rect;
    bx(): Point;
    ba(): void;
    b2: Rect;
    private l;
    av(): void;
    private bi;
    private bz;
    protected a5(): void;
    protected a6(): void;
    private a8;
    private a9;
    private a7;
    private m;
    aj(a: Point, b: boolean, c: boolean): void;
    ai(a: Point): void;
    ah(a: Point): void;
    ak(a: Point): void;
    private ap;
    protected f: Slice;
    private bj;
    n(a: Point): boolean;
    p(a: Point): boolean;
    o(a: Point): boolean;
    private bd;
    al(): void;
    bn(a: any, b: any): void;
    protected u: List$1<Slice>;
    g(): Slice;
    be(a: Slice): void;
    bg(a: Slice): void;
    bf(a: Slice): void;
    protected t: List$1<PieLabel>;
    d(): PieLabel;
    ar(a: PieLabel): void;
    at(a: PieLabel): void;
    as(a: PieLabel): void;
    bl(a: PieLabel): void;
    bc(a: Slice): void;
    private bv;
    private bw;
    ad(a: Slice): any;
    y(a: any): number;
    bk(): void;
    v: number;
    x(a: any): number;
    b1(a: PieLabel): Rect;
    b3(): Size;
    bm(a: PieLabel, b: number, c: number): void;
    bp(a: any): void;
    br(): void;
    au(): void;
    private am;
    az(a: number, b: number): void;
    aw(): void;
    protected by: Point;
    protected ag: any;
    protected s: boolean;
    protected e: PieSliceDataContext;
    get af(): any;
    aq(): void;
    bq(a: any): void;
    bo(a: Point, b: any, c: any): void;
    bh(): void;
    a2(): void;
    ac(): any;
    ao(): void;
    r(): boolean;
    an(a: PieChartVisualData): void;
    q(): boolean;
    a4(): void;
    bt(a: Slice): Brush;
    bu(a: Slice): Brush;
    w(a: Slice): number;
    z(a: Style): number;
    aa(): number;
    a3(): void;
    ae(a: any): any;
}
/**
 * @hidden
 */
export declare class PieSliceDataContext extends DataContext {
    static $t: Type;
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    private _percentValue;
    get percentValue(): number;
    set percentValue(a: number);
    private _isOthersSlice;
    get isOthersSlice(): boolean;
    set isOthersSlice(a: boolean);
    flatten(): any;
}
/**
 * @hidden
 */
export declare class SliceView extends Base {
    static $t: Type;
    protected a: Slice;
    constructor(a: Slice);
    g: Path;
    b(): void;
    c(): void;
    f(): Path;
    d(a: number, b: number): void;
    e(): void;
}
